<?php
// *** BlognPet Module ***
//
// blognpet.php v0.9.10
// Copyright takayan
// LAST UPDATE 2007/07/22
//
//--------------------------------------------------------------------
if(!defined('BLOGPETDIR'))exit;

include("./conf.php"   );
include("./common.php" );
include( BLOGPETDIR . 'xmlrpc.inc.php' );
include( BLOGPETDIR . 'xmlrpcs.inc.php');

define( 'LOGIN_ERROR',        $xmlrpcerruser+1 );
define( 'USERDATALOAD_ERROR', $xmlrpcerruser+2 );
define( 'USERPROFILE_ERROR',  $xmlrpcerruser+3 );
define( 'POST_ERROR',         $xmlrpcerruser+4 );


function false_result() {
	return new xmlrpcresp(new xmlrpcval( false, 'boolean'));
}


/*
function true_result() {
	return new xmlrpcresp(new xmlrpcval( true, 'boolean'));
}
*/


function blogndate_iso8601($date) {
	return date("Ymd\TH:i:s",
		mktime(substr($date,8,2),substr($date,10,2),substr($date,12,2),
					substr($date,4,2), substr($date,6,2), substr($date,0,4)));
}


function get_param( $params, $number ) {
	$val = $params -> getParam( $number );
	return $val -> scalarval();
}


function metaWeblog_newPost($params) {

	$username = get_param($params,1);
	$password = get_param($params,2);
	$result = blogn_mod_db_user_check( $username, $password );
	if (!$result[0])
		return new xmlrpcresp( 0, LOGIN_ERROR, 'BlognPet Fault #'. LOGIN_ERROR );

	$result = blogn_mod_db_user_load();
	if(!$result)
		return new xmlrpcresp( 0, USERDATALOAD_ERROR, "BlognPet Fault #". USERDATALOAD_ERROR );
	foreach( $result as $key => $val ) {
		if ( $val['id'] == $username ) {
			$user_key = $key;
			break;
		}
	}

	$userlist = blogn_mod_db_user_profile_load($user_key);
	if (!$userlist)
		return new xmlrpcresp( 0, USERPROFILE_ERROR, "BlognPet Fault #". USERPROFILE_ERROR );

	$content = get_param($params,3);

	$date         = date("YmdHis");
	$reserve      = get_param($params,4) ? true : false;
	$secret       = false;
	$comment_ok   = ( $value = $content["mt_allow_comments"] ) ? $value -> scalarval() : $userlist["init_comment_ok"  ];
	$comment_ok   = $comment_ok ? true : false;
	$trackback_ok = ( $value = $content["mt_allow_pings"] )    ? $value -> scalarval() : $userlist["init_trackback_ok"];
	$trackback_ok = $trackback_ok ? true : false;
	$category     = $userlist['init_category'];
	$title        = ( $value = $content["title"]        ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '(タイトル無し)';
	$mes          = ( $value = $content["description"]  ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
	$more         = ( $value = $content["mt_text_more"] ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
	$br_change    = ( $value = $content["mt_convert_breaks"] ) ? $value->scalarval() : $userlist["br_change"];
	$br_change    = $br_change ? true : false;

	$result = blogn_mod_db_log_add($user_key, $date, $reserve, $secret, $comment_ok, $trackback_ok,
			$category, $title, $mes, $more, $br_change);

	if(!$result[0])
		return new xmlrpcresp( 0, POST_ERROR, "BlognPet Fault #" . POST_ERROR );
	return new xmlrpcresp(new xmlrpcval( $result[2], 'string' ));
}


function metaWeblog_getPost ($params) {

	$username = get_param($params,1);
	$password = get_param($params,2);
	$result = blogn_mod_db_user_check( $username, $password );
	if (!$result[0])
		return false_result();

	$postid = get_param($params,0);
	$log = blogn_mod_db_log_load_for_entory($username, $postid);
	if(!$log[0])
		return false_result();

	$userid            = $username;
	$dateCreated       = blogndate_iso8601( $log[1]['date'] );
	$description       = htmlspecialchars( $log[1]["mes"]   );
	$title             = htmlspecialchars( $log[1]["title"] );
	$link              = BLOGN_HOMELINK.'?e='.$log[1]["id"];
	$permaLink         = $link;
	$mt_excerpt        = '';
	$mt_text_more      = htmlspecialchars($log[1]["more"]);
	$mt_allow_comments = $log[1]["comment_ok"]   ? true : false;
	$mt_allow_pings    = $log[1]["trackback_ok"] ? true : false;
	$mt_convert_breaks = $log[1]["br_change"]    ? true : false;
	$mt_keywords       = '';

	$struct = array(
		'userid'             => new xmlrpcval( $userid,            'string')
		,'dateCreated'       => new xmlrpcval( $dateCreated,       'dateTime.iso8601')
		,'postid'            => new xmlrpcval( $postid,            'string')
		,'description'       => new xmlrpcval( $description,       'string')
		,'title'             => new xmlrpcval( $title,             'string')
		,'link'              => new xmlrpcval( $link,              'string')
		,'permaLink'         => new xmlrpcval( $permaLink,         'string')
		,'mt_excerpt'        => new xmlrpcval( $mt_excerpt,        'string')
		,'mt_text_more'      => new xmlrpcval( $mt_text_more,      'string')
		,'mt_allow_comments' => new xmlrpcval( $mt_allow_comments, 'string')
		,'mt_allow_pings'    => new xmlrpcval( $mt_allow_pings,    'string')
		,'mt_convert_breaks' => new xmlrpcval( $mt_convert_breaks, 'string')
		,'mt_keywords'       => new xmlrpcval( $mt_keywords,       'string')
	);

	return new xmlrpcresp(new xmlrpcval( $struct, 'struct'));
}


function metaWeblog_getRecentPosts ($params) {
//	$blogid = get_param($params,0);

	$username = get_param($params,1);
	$password = get_param($params,2);
	$result = blogn_mod_db_user_check( $username, $password );
	if (!$result[0])
		return false_result();

	$numberOfPosts = get_param($params,3);
	if ($numberOfPosts<=0)
		return false_result();
	$loglist = blogn_mod_db_log_load_for_viewer($username, 0, $numberOfPosts);
	if (!$loglist[0])
		return false_result();

	$array = array();
	foreach ( $loglist[1] as $key => $val ) {
			$struct = array(
			'dateCreated'        => new xmlrpcval( blogndate_iso8601($val['date']), 'dateTime.iso8601')
			,'userid'            => new xmlrpcval( $username,                       'string')
			,'postid'            => new xmlrpcval( $val['id'],                      'string')
			,'content'           => new xmlrpcval( htmlspecialchars($val['mes']),   'string')
			,'description'       => new xmlrpcval( htmlspecialchars($val['mes']),   'string')
			,'title'             => new xmlrpcval( htmlspecialchars($val['title']), 'string')
			,'link'              => new xmlrpcval( BLOGN_HOMELINK.'?e='.$val["id"], 'string')
			,'permaLink'         => new xmlrpcval( BLOGN_HOMELINK.'?e='.$val["id"], 'string')
			,'mt_excerpt'        => new xmlrpcval( '',                              'string')
			,'mt_text_more'      => new xmlrpcval( htmlspecialchars($val['more']),  'string')
			,'mt_allow_comments' => new xmlrpcval( $val['comment_ok']?true:false,   'int')
			,'mt_allow_pings'    => new xmlrpcval( $val['trackback_ok']?true:false, 'string')
			,'mt_convert_breaks' => new xmlrpcval( $val['br_change']?true:false,    'string')
			,'mt_keywords'       => new xmlrpcval( '',                              'string')
		);
		$array[] = new xmlrpcval( $struct, 'struct');
	}
	return new xmlrpcresp(new xmlrpcval( $array, 'array'));
}


function mt_supportedMethods ($params) {
	$methods = array(
		 'metaWeblog.newPost'
		,'metaWeblog.getRecentPosts'
//		,'mt.supportedMethods'
	);

	$array = array();
	foreach( $methods as $method ) {
		$array[] = new xmlrpcval( $method, 'string' );
	}
	return new xmlrpcresp(new xmlrpcval( $array, 'array' ));
}


$metaWeblog_newPost_sig = array(array( 'string', 'string', 'string', 'string', 'struct', 'boolean' ));
$metaWeblog_newPost_doc = '';
$metaWeblog_newPost_ary = array( 'function' => 'metaWeblog_newPost',
	'signature' => $metaWeblog_newPost_sig, 'docstring' => $metaWeblog_newPost_doc );

$metaWeblog_getPost_sig = array(array('struct', 'string', 'string','string'));
$metaWeblog_getPost_doc = '';
$metaWeblog_getPost_ary = array('function'=>'metaWeblog_getPost',
	'signature'=>$metaWeblog_getPost_sig,'docstring'=>$metaWeblog_getPost_doc);

$metaWeblog_getRecentPosts_sig = array(array('array', 'string', 'string','string','int'));
$metaWeblog_getRecentPosts_doc = '';
$metaWeblog_getRecentPosts_ary = array('function'=>'metaWeblog_getRecentPosts',
	'signature'=>$metaWeblog_getRecentPosts_sig,'docstring'=>$metaWeblog_getRecentPosts_doc);

$mt_supportedMethods_sig = array(array('array'));
$mt_supportedMethods_doc = '';
$mt_supportedMethods_ary = array('function'=>'mt_supportedMethods');


$server = new xmlrpc_server( array(
		 'metaWeblog.newPost' => $metaWeblog_newPost_ary
		,'metaWeblog.getPost' => $metaWeblog_getPost_ary
		,'metaWeblog.getRecentPosts' => $metaWeblog_getRecentPosts_ary
		,'mt.supportedMethods' => $mt_supportedMethods_ary
		));

?>
