<?php
//--------------------------------------------------------------------
// *** BlognPet Module ***
//
// function.php v0.9.0
// Copyright takayan
// LAST UPDATE 2007/01/11
//
//--------------------------------------------------------------------

/*----- 定数宣言 -----*/
define( 'BLOGN_PET_MODULE',    basename(dirname(__FILE__)) );	// モジュールフォルダ名
define( 'BLOGN_PET_INIFILE',   'ini.cgi'                   );	// 設定ファイル名
define( 'BLOGN_PET_INIPATH',   './'.BLOGN_MODDIR.BLOGN_PET_MODULE.'/'.BLOGN_PET_INIFILE );	// 設定ファイルパス
define( 'BLOGN_PET_TAG',       '{BLOGN_PET}'       );	// スクリプトタグ名
define( 'BLOGN_PET_FIELD_TAG', '{BLOGN_PET_FIELD}' );	// フィールドタグ名
define( 'BLOGN_PET_TEMPLATE',  'setting.html'      );	// 設定画面のテンプレートファイル名
define( 'BLOGN_QRY_MODE_PET',  'pet'               );	// (拡張タブリストでの)クエリモード名

/*----- 関数宣言 -----*/

// スクリプトの登録
function blogn_mod_petdata_update($mode,$script,$enable) {

	// 設定ファイル
	$inifile = BLOGN_PET_INIPATH;

	// データ読み込み
	if ( $scripts = file($inifile) ) {
		if ($enable_old  = array_shift($scripts) ) {
			$enable_old = (rtrim($enable_old)!='off')?'on':'off';
			$script_old = implode( '', $scripts );
		} else {
			$enable_old = '';
			$script_old = '';
		}
	} else {
		$enable_old  = 'on';
		$script_old  = '';
	}

	// データの補完
	if ($mode==0) {
		$enable = $enable_old;
	} else {
		$script = $script_old;
	}

	// ファイルオープン
	$fp = @fopen($inifile, 'w');

	// ファイルロック
	if (!blogn_mod_petdata_file_lock(BLOGN_PET_INIFILE)) {
		$result[0] = false;
		$result[1] = '設定ファイルがビジーです。少し待ってから実行してください。';
		$result[2] = $script;
		$result[3] = $enable;
		return $result;
	}

	// ファイル書き込み
	fputs( $fp, $enable );
	fputs( $fp, "\n"    );
	fputs( $fp, $script );

	// ファイルクローズ
	fclose($fp);

	// ロック解除
	if (!blogn_mod_petdata_file_unlock(BLOGN_PET_INIFILE)) {
		$result[0] = false;
		$result[1] = '致命的なエラー。ファイルのロックが解除できませんでした。';
		$result[2] = $script;
		$result[3] = $enable;
		return $result;
	}

	// 正常終了
	$result[0] = true;
	$result[1] = '設定は更新されました。';
	$result[2] = $script;
	$result[3] = $enable;
	return $result;
}

// 設定ファイルチェック
function blogn_mod_petdata_ini_check() {

	// ファイルが存在しない場合、新規作成
	$inifile = BLOGN_PET_INIPATH;
	if (!$fp = @fopen($inifile, 'r+')) {
		$oldmask = umask();
		umask(000);
		if (!$fp = @fopen($inifile, 'w')) {
			umask($oldmask);
			$result[0] = false;
			$result[1] = '設定ファイルを作成できません。設定ファイルのパーミッションを確認してください。';
			$result[2] = '';
			$result[3] = 'on';
			return $result;
		}else{
			umask($oldmask);
			$result[0] = true;
			$result[1] = '設定ファイルを新しく作成しました。';
			$result[2] = '';
			$result[3] = 'on';
			return $result;
		}
	}

	// データの読み込み
	$enable = 'on';
	$script = '';
	if( $scripts = file ($inifile) ) {
		if ( $enable = array_shift($scripts) ) {
			$enable = ( rtrim($enable) != 'off' ) ? 'on' : 'off';
			$script = implode('', $scripts);
		} else {
			$enable = 'on';
		}
	}

	$result[0] = true;
	$result[1] = '設定ファイルを読み込みました。';
	$result[2] = $script;
	$result[3] = $enable;
	return $result;
}


// ロック
function blogn_mod_petdata_file_lock($name) {
	for ($i = 0; $i < 5; $i++) {
		if (@mkdir('./'.BLOGN_MODDIR.BLOGN_PET_MODULE.'/lock/'.$name )) {
			return true;
		}
		sleep(1);
	}
	return false;
}

// アンロック
function blogn_mod_petdata_file_unlock($name) {
	return rmdir('./'.BLOGN_MODDIR.BLOGN_PET_MODULE.'/lock/'.$name);
}

// 管理ページ描画
function pet_control_page($action,$mode) {
	$blogn_skin = file('./'.BLOGN_MODDIR.BLOGN_PET_MODULE.'/'.BLOGN_PET_TEMPLATE);
	$blogn_skin = implode('',$blogn_skin);

	// クエリアクション毎のインフォメーション及びスクリプトの獲得
	switch($action) {
		case 'enable':
			$enable = $_POST['blogn_pet_enable'];
			$result = blogn_mod_petdata_update(1,'',$enable);
			break;

		case 'regist':
			$script = $_POST['blogn_pet_script'];
			$result = blogn_mod_petdata_update(0,$script,'');
			break;

		default:
			$result = blogn_mod_petdata_ini_check();

			break;
	}

	// 変数の代入
	$script = $result[2];
	$enable = $result[3];

	// インフォメーション表示
	$blogn_skin = str_replace ('{BLOGN_INFORMATION}', blogn_information_bar($result[0], $result[1]), $blogn_skin );

	// スクリプト
	$script = blogn_magic_quotes($script);
	$blogn_skin = str_replace ('{BLOGN_PET_SCRIPT}', $script, $blogn_skin);

	// 挿入するタグ
	$tag = BLOGN_PET_TAG;
	if( defined('BLOGN_CLEANUP_TAG_EXT') )
		$tag = BLOGN_PET_FIELD_TAG.'{BEGIN}'.$tag.'{END}';
	$blogn_skin = str_replace ('{BLOGN_PET_TAG}', $tag, $blogn_skin );

	// 表示状態
	$string = ($enable!='off') ? '表示可能' : '表示不可';
	$blogn_skin = str_replace ('{BLOGN_PET_ENABLE_STATE}', $string, $blogn_skin );

	// 表示状態変更ボタン
	$button = ($enable!='off') ? '表示不可' : '表示可能';
	$blogn_skin = str_replace ('{BLOGN_PET_ENABLE_BUTTON}', $button, $blogn_skin );

	// 表示非表示戻り値
	$blogn_skin = str_replace ('{BLOGN_PET_ENABLE}', ($enable=='on')?'off':'on', $blogn_skin );

	// クエリモード
	$blogn_skin = str_replace ('{BLOGN_QRY_MODE_PET}', $mode, $blogn_skin );

	echo $blogn_skin;
}

?>